
/************************************************************************/
/*                                                                      */
/*  Disk Free-space defragmenter   - PLUG.C	July,  1987		*/
/*                                                                      */
/*	Version 1.0, July  1987 					*/
/*                                                                      */
/*	Compiled under Lattice C version 3.20	(Large model -mls)	*/
/*                                                                      */
/*	Author: Lawrence E. Himes					*/
/*                                                                      */
/*                                                                      */
/************************************************************************/

#include "bpb.h"
#include <stdio.h>
#include "dglobal.h"

/****************************************************************/
/*                                                              */
/*      PLUG     () - Main function                             */
/*                                                              */
/****************************************************************/

main (argc, argv)
  int argc;
  char **argv;
{
  int d;
  static struct {
        char fn [8];
        char f;
        char fe[8];
  } b ;

        setmem (&b , 16, ' ');
        b.fe [7] = 0;
        if (argc != 2)  {
                cprintf ("\nUsage: PLUG D:");
                cprintf ("\n    D: = Drive Id.\n");
                return 8;
        }
        d = toupper (*(argv [1])) - 'A';
        d =  loadbpb (d);
        int_err (d, "Reading Boot Record");
        if (secsize != 512)  {          /* We only handle 512-byte sectors */
                cprintf ("\nSorry, drive %s has an unusual sector size.",
                                argv [1]);
                cprintf ("\nPLUG works only with drives having 512-byte sectors.");
                return (8);
        }
        d = loadfat (&FAT);
        int_err (d, "Loading FATs");
        d = loadroot ();
        int_err (d, "Loading Root Directory");
        d = loadsubs ();
        int_err (d, "Loading Sub-directories");
        d = blddpl ();
        int_err (d, "Building Dir Pointer List");
        d = sortdpl ();
        int_err (d, "Sorting Dir Pointer List");
        d = fmover ();
        int_err (d, "Plugging Holes ");
        return (0);
}

/****************************************************************/
/*                                                              */
/*	int_err  () - Interpret error code - exit on error	*/
/*                                                              */
/****************************************************************/

int_err (err, s)
  int err;
  char *s;
{
  static char *msg[] =  {
        "DOS Disk Error Code = %d",
        "No error",
        "Insufficient Memory",
        "Compare Error",
        NULL       } ;
  int i;
  char buf [80];

        if ((err & 0xff00) == 0x8000)  { i = 0; err &= 0xff;  }
        else  i = -(err - 1);
        sprintf (buf, msg [i], err);
        cprintf ("\n%s  %s", buf, s);
        if (i != 1) exit (8);
        return i;
}
